---
title: RTCPeerConnection.createAnswer()
slug: Web/API/RTCPeerConnection/createAnswer
tags:
  - API
  - Experimental
  - Media
  - Method
  - RTCPeerConnection
  - Reference
  - Video
  - Web
  - WebRTC
  - createAnswer
---
<p>{{APIRef("WebRTC")}}</p>

<p>The <strong><code>createAnswer()</code></strong> method on the {{domxref("RTCPeerConnection")}} interface creates an {{Glossary("SDP")}} answer to an offer received from a remote peer during the offer/answer negotiation of a WebRTC connection. The answer contains information about any media already attached to the session, codecs and options supported by the browser, and any {{Glossary("ICE")}} candidates already gathered. The answer is delivered to the returned {{jsxref("Promise")}}, and should then be sent to the source of the offer to continue the negotiation process.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>aPromise</em> = <em>RTCPeerConnection</em>.createAnswer([<em>options</em>]);

<em>RTCPeerConnection</em>.createAnswer(<em>successCallback</em>, <em>failureCallback</em>[, <em>options</em>]); {{deprecated_inline}}</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An object which contains options which customize the answer; this is based on the {{domxref("RTCAnswerOptions")}} dictionary.</dd>
</dl>

<h3 id="Deprecated_parameters">Deprecated parameters</h3>

<p>In older code and documentation, you may see a callback-based version of this function. This has been deprecated and its use is <strong>strongly</strong> discouraged. You should update any existing code to use the {{jsxref("Promise")}}-based version of <code>createAnswer()</code> instead. The parameters for this form of <code>createAnswer()</code> are described below, to aid in updating existing code.<strong> </strong></p>

<dl>
 <dt><code>successCallback</code> {{deprecated_inline}}</dt>
 <dd>An {{domxref("RTCSessionDescriptionCallback")}} which will be passed a single {{domxref("RTCSessionDescription")}} object describing the newly-created answer.</dd>
 <dt><code>failureCallback</code> {{deprecated_inline}}</dt>
 <dd>An {{domxref("RTCPeerConnectionErrorCallback")}} which will be passed a single {{domxref("DOMException")}} object explaining why the request to create an answer failed.</dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An optional {{domxref("RTCOfferOptions")}} object providing options requested for the answer.</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>NotReadableError</code></dt>
 <dd>The identity provider wasn't able to provide an identity assertion.</dd>
 <dt><code>OperationError</code></dt>
 <dd>Generation of the SDP failed for some reason; this is a general failure catch-all exception.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} whose fulfillment handler is called with an object conforming to the {{domxref("RTCSessionDescriptionInit")}} dictionary which contains the SDP answer to be delivered to the other peer.</p>

<h2 id="Example">Example</h2>

<p>Here is a segment of code taken from the code that goes with the article <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>. This code comes from the handler for the message sent to carry an offer to another peer across the signaling channel.</p>

<div class="note">
<p>Keep in mind that this is part of the signaling process, the transport layer for which is an implementation detail that's entirely up to you. In this case, a <a href="/en-US/docs/Web/API/WebSocket_API">WebSocket</a> connection is used to send a {{Glossary("JSON")}} message with a <code>type</code> field with the value "video-answer" to the other peer, carrying the answer to the device which sent the offer to connect. The contents of the object being passed to the <code>sendToServer()</code> function, along with everything else in the promise fulfillment handler, depend entirely on your design</p>
</div>

<pre class="brush: js">pc.createAnswer().then(function(answer) {
  return pc.setLocalDescription(answer);
})
.then(function() {
  // Send the answer to the remote peer through the signaling server.
})
.catch(handleGetUserMediaError);
</pre>

<p>This asks {{domxref("RTCPeerConnection")}} to create and return a new answer. In our promise handler, the returned answer is set as the description of the local end of the connection by calling {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}}.</p>

<p>Once that succeeds, the answer is sent to the signaling server using whatever protocol you see fit.</p>

<p>{{jsxref("Promise.catch()")}} is used to trap and handle errors.</p>

<p>See {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling", "Handling the invitation")}} to see the complete code, in context, from which this snippet is derived; that will help you understand the signaling process and how answers work.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-createanswer', 'createAnswer()')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.createAnswer")}}</p>
